#include <AltSoftSerial.h>


AltSoftSerial mySerial; // RX, TX
#include <FTOLED.h>
#include <FTOLED_Colours.h>
#include <progmem_compat.h>

char* AsciiArray[]={
"<NUL>",
"<SOH>",
"<STX>",
"<ETX>",
"<EOT>",
"<ENQ>",
"<ACK>",
"<BEL>",
"<BS>",
"<HT>",
"<LF>",
"<VT>",
"<FF>",
"<CR>",
"<SO>",
"<SI>",
"<DEL>",
"<DC1>",
"<DC2>",
"<DC3>",
"<DC4>",
"<NAK>",
"<SYN>",
"<ETB>",
"<CAN>",
"<EM>",
"<SUB>",
"<ESC>",
"<FS>",
"<GS>",
"<RS>",
"<US>",
" ",
"!",
"\"",
"#",
"$",
"%",
"&",
"'",
"(",
")",
"*",
"+",
",",
"-",
".",
"/",
"0",
"1",
"2",
"3",
"4",
"5",
"6",
"7",
"8",
"9",
":",
";",
"<",
"=",
">",
"?",
"@",
"A",
"B",
"C",
"D",
"E",
"F",
"G",
"H",
"I",
"J",
"K",
"L",
"M",
"N",
"O",
"P",
"Q",
"R",
"S",
"T",
"U",
"V",
"W",
"X",
"Y",
"Z",
"[",
"\\",
"]",
"^",
"_",
"`",
"a",
"b",
"c",
"d",
"e",
"f",
"g",
"h",
"i",
"j",
"k",
"l",
"m",
"n",
"o",
"p",
"q",
"r",
"s",
"t",
"u",
"v",
"w",
"x",
"y",
"z",
"{",
"|",
"}",
"~",
"<DEL>"
};

#include <fonts/Arial14.h>

const byte pin_cs = 7;
const byte pin_dc = 2;
const byte pin_reset = 3;

OLED oled(pin_cs, pin_dc, pin_reset);
/* OLED_TextBox box(oled); */

const int buttonPin = 4;
const int blen=17;
int buttonstate;
int oldstate;
unsigned long lasttime;
unsigned long curtime;
byte bitval =1;
byte bitcnt=1;
byte byteval=0;

byte ibuf[21];
byte obuf[21];

void setup() {
  // put your setup code here, to run once:

for (int i=0;i<blen;i++)
  {
    ibuf[i]=20;
    obuf[i]=20;
  }
ibuf[blen-1]=0;
obuf[blen-1]=0; 

 Serial.begin(9600);
 mySerial.begin(4800); // 4800 baud tx on 8 rx on 9
 pinMode(buttonPin, INPUT_PULLUP);

 
/* Initialise display */

  oled.begin();
  oled.selectFont(Arial14);
 /* box.setForegroundColour(OLDLACE); */
  oled.clearScreen();
  oled.drawString(20, 127-15, "1 Key Terminal", BLUE, BLACK);
  oled.drawLine(  0, 127-16, 128, 127-16, BLUE );
  oled.drawLine(  0, 127, 127, 127, BLUE );
  oled.drawLine(  128, 127, 127, 127-16, BLUE );
  oled.drawLine(  0, 127, 0, 127-16, BLUE );
  buttonstate=digitalRead(buttonPin);
  oldstate=buttonstate;
  lasttime=millis();
  oled.drawString(1 ,15,"0",RED,BLACK); 

}

void printBits(byte myByte)
{
 for (byte mask = 0x80; mask; mask >>= 1)
    {
      if(mask  & myByte)
          Serial.print('1');
      else
          Serial.print('0');
    }
 }
 
void shiftbuf(byte* buf, char* str)
{

  for (int n=0;n<strlen(str);n++)
  {
     for (int i=0;i<blen-1;i++)
     {
        buf[i]=buf[i+1];
        
     }
     buf[blen-2]=(byte)str[n];
  }
}
void loop() {

    while (mySerial.available())
    {
      char i;
      i= mySerial.read();

      
      shiftbuf(ibuf,(char*)AsciiArray[i]);
      oled.drawString(1,127-68,(char*)ibuf,WHITE,BLACK);

      
    }

    
    curtime=millis();
    buttonstate=digitalRead(buttonPin);
    if (oldstate!=buttonstate)
    {
      oldstate=buttonstate;
      
  
      if (buttonstate==0)
      { 
    
        int shift=7-bitcnt;
       
        byte bc=bitval<<(7-bitcnt);
  
        byteval=byteval+bc;

        bitcnt++;
  
        byte mask=0x80;
        for (int n=0;n<bitcnt;n++)
        {
           if (mask & byteval)
           {
              oled.drawString(1+(n * 10) ,15,"1  ",RED,BLACK);  
           }
           else
           {
            oled.drawString(1+(n * 10) ,15,"0",RED,BLACK); 
           }
           if (n==bitcnt)
            break;
           mask=mask>>1;
        }
        
        } 
    }

    if (bitcnt > 7)
    {
  
      oled.drawString(8,35,AsciiArray[byteval],RED,BLACK);

      shiftbuf(obuf,(char*)AsciiArray[byteval]);

      oled.drawString(1,127-38,(char*)obuf,GREEN,BLACK);
      mySerial.write(byteval);
      

      oled.drawString(8,35,"            ",RED,BLACK); 
      oled.drawString(10,15,"            ",RED,BLACK); 
      bitcnt=1; /* First bit is always 0 - 7bit ascii) */
      byteval=0;
    }


    
    if (curtime - lasttime > 1000)
    {
      lasttime=curtime;
      if (bitval==0)
      {
        bitval=1;
        oled.drawString(100,15,"  ",RED,BLACK); 
        oled.drawString(100,15,"1",RED,BLACK);  
      } else
      {
        bitval=0;
        oled.drawString(100,15,"  ",RED,BLACK); 
        oled.drawString(100,15,"0",RED,BLACK); 
      }
    }
}
